## doctest 0.2.0

=== DESCRIPTION ===
Package: doctest
Type: Package
Title: Generate Tests from Examples Using 'roxygen' and 'testthat'
Version: 0.2.0
Authors@R: person("David", "Hugh-Jones",
                          email = "davidhughjones@gmail.com",
                          role = c("aut", "cre"))
Maintainer: David Hugh-Jones <davidhughjones@gmail.com>
Description: Creates 'testthat' tests from 'roxygen' examples using simple tags.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.2.3
Imports: cli, fs, pkgload, purrr, rlang, roxygen2, testthat
Suggests: covr, knitr, lifecycle, rmarkdown
Config/testthat/edition: 3
URL: https://hughjonesd.github.io/doctest/
BugReports: https://github.com/hughjonesd/doctest/issues
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2023-04-27 12:41:54 UTC; david
Author: David Hugh-Jones [aut, cre]
Repository: CRAN
Date/Publication: 2023-04-28 17:50:05 UTC

## doctest 0.3.0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: doctest
 Type: Package
 Title: Generate Tests from Examples Using 'roxygen' and 'testthat'
-Version: 0.2.0
+Version: 0.3.0
 Authors@R: person("David", "Hugh-Jones",
                           email = "davidhughjones@gmail.com",
                           role = c("aut", "cre"))
@@ -17,7 +17,7 @@
 BugReports: https://github.com/hughjonesd/doctest/issues
 VignetteBuilder: knitr
 NeedsCompilation: no
-Packaged: 2023-04-27 12:41:54 UTC; david
+Packaged: 2024-01-11 21:54:34 UTC; davidhugh-jones
 Author: David Hugh-Jones [aut, cre]
 Repository: CRAN
-Date/Publication: 2023-04-28 17:50:05 UTC
+Date/Publication: 2024-01-11 22:10:02 UTC

## doctest 0.4.0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: doctest
 Type: Package
 Title: Generate Tests from Examples Using 'roxygen' and 'testthat'
-Version: 0.3.0
+Version: 0.4.0
 Authors@R: person("David", "Hugh-Jones",
                           email = "davidhughjones@gmail.com",
                           role = c("aut", "cre"))
@@ -17,7 +17,7 @@
 BugReports: https://github.com/hughjonesd/doctest/issues
 VignetteBuilder: knitr
 NeedsCompilation: no
-Packaged: 2024-01-11 21:54:34 UTC; davidhugh-jones
+Packaged: 2026-02-19 11:23:57 UTC; davidhugh-jones
 Author: David Hugh-Jones [aut, cre]
 Repository: CRAN
-Date/Publication: 2024-01-11 22:10:02 UTC
+Date/Publication: 2026-02-19 12:00:02 UTC

=== tests/testthat/testPackage/DESCRIPTION ===
Package: testPackage
Title: A Testing Package Only
Version: 0.0.0.9000
Authors@R: 
    person("First", "Last", , "first.last@example.com", role = c("aut", "cre"),
           comment = c(ORCID = "YOUR-ORCID-ID"))
Maintainer: Dummy <dummy@example.com>
Author: Dummy <dummy@example.com>
Description: What the package does (one paragraph).
License: MIT + file LICENSE
Encoding: UTF-8
Roxygen: list(markdown = TRUE, 
         roclets = c("collate", "rd", "namespace", "doctest::dt_roclet")) 
RoxygenNote: 7.2.3
Suggests: testthat

## doctest 1.2.7%2Brepack0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

################################################################################
## DOCTEST
################################################################################

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/scripts/version.txt ver)
project(doctest VERSION ${ver})

option(DOCTEST_WITH_TESTS               "Build tests/examples" ON)
option(DOCTEST_WITH_MAIN_IN_STATIC_LIB  "Build a static lib (cmake target) with a main entry point" ON)
option(DOCTEST_NO_INSTALL  "Skip the installation process" OFF)

add_library(${PROJECT_NAME} INTERFACE)
target_include_directories(${PROJECT_NAME} INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/doctest/>)

################################################################################
## TESTS/EXAMPLES/HELPERS
################################################################################

if(${DOCTEST_WITH_MAIN_IN_STATIC_LIB})
    include(scripts/cmake/common.cmake)
    doctest_add_library(${PROJECT_NAME}_with_main STATIC EXCLUDE_FROM_ALL doctest/parts/doctest_main.cpp)
    target_link_libraries(${PROJECT_NAME}_with_main PUBLIC ${PROJECT_NAME})
endif()

if(${DOCTEST_WITH_TESTS})
    include(scripts/cmake/common.cmake)

    add_subdirectory(examples/all_features)
    
    if(NOT DEFINED ENV{CODE_COVERAGE})
        add_subdirectory(examples/exe_with_static_libs)
        add_subdirectory(examples/executable_dll_and_plugin)
        add_subdirectory(scripts/playground)
    endif()
endif()

################################################################################
## PACKAGE SUPPORT
################################################################################

set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")

set(include_install_dir "include/doctest/")
set(config_install_dir "lib/cmake/${PROJECT_NAME}")

set(version_config "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(targets_export_name "${PROJECT_NAME}Targets")
set(namespace "${PROJECT_NAME}::")

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    "${version_config}" VERSION ${PROJECT_VERSION} COMPATIBILITY SameMajorVersion
)

configure_file("scripts/cmake/Config.cmake.in" "${project_config}" @ONLY)

if (NOT ${DOCTEST_NO_INSTALL})
    install(
        TARGETS ${PROJECT_NAME}
        EXPORT "${targets_export_name}"
        INCLUDES DESTINATION "${include_install_dir}"
    )

    install(
        FILES "doctest/doctest.h"
        DESTINATION "${include_install_dir}"
    )

    install(
        FILES "${project_config}" "${version_config}"
        DESTINATION "${config_install_dir}"
    )

    install(
        EXPORT "${targets_export_name}"
        NAMESPACE "${namespace}"
        DESTINATION "${config_install_dir}"
    )
endif()

=== examples/executable_dll_and_plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(executable_dll_and_plugin)

include(../../scripts/cmake/common.cmake)

include_directories(../../doctest/)

if(APPLE)
    set(CMAKE_MACOSX_RPATH ON)
    if(DEFINED ENV{TRAVIS})
        # force 64 bit for OSX because -m32 fails >>> SOMETIMES <<< (x86_64 vs 386 - like the dll is not linked with -m32...)
        add_compiler_flags(-m64)
    endif()
endif()

doctest_add_library(implementation SHARED implementation.cpp implementation_2.cpp)

doctest_add_library(dll SHARED dll.cpp)
target_link_libraries(dll implementation)

doctest_add_library(plugin SHARED plugin.cpp)
target_link_libraries(plugin implementation)

doctest_add_executable(${PROJECT_NAME} main.cpp)
target_link_libraries(${PROJECT_NAME} dll)
target_link_libraries(${PROJECT_NAME} implementation)

if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME} dl)
endif()

# have the executable depend on the plugin so it gets built as well when building/starting only the executable
add_dependencies(${PROJECT_NAME} plugin)

#== group them together in a single folder inside IDEs
set_target_properties(implementation PROPERTIES FOLDER ${PROJECT_NAME})
set_target_properties(dll PROPERTIES FOLDER ${PROJECT_NAME})
set_target_properties(plugin PROPERTIES FOLDER ${PROJECT_NAME})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${PROJECT_NAME})

doctest_add_test(NAME ${PROJECT_NAME} COMMAND $<TARGET_FILE:${PROJECT_NAME}> --no-version)

## doctest 1.2.7+repack0

=== examples/all_features/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(all_features)

include(../../scripts/cmake/common.cmake)

include_directories(../../doctest/)

################################################################################
## BUILD ALL EXAMPLE SOURCES INTO A SINGLE BINARY AND EXECUTE TESTS ON EACH FILE
################################################################################

set(files
    main.cpp
    doctest_proxy.h
    header.h
    coverage_maxout.cpp
    alternative_macros.cpp
    assertion_macros.cpp
    stringification.cpp
    subcases.cpp
    logging.cpp
    templated_test_cases.cpp
    test_cases_and_suites.cpp
)

doctest_add_executable(${PROJECT_NAME} ${files})
# easy way to fix test coverage - disable colors and crash handling
target_compile_definitions(${PROJECT_NAME} PRIVATE
    DOCTEST_CONFIG_COLORS_NONE
    DOCTEST_CONFIG_NO_POSIX_SIGNALS
    DOCTEST_CONFIG_NO_WINDOWS_SEH)

set(common_args COMMAND $<TARGET_FILE:${PROJECT_NAME}> --no-skipped-summary --no-version)

# add per-file tests
foreach(f ${files})
    doctest_add_test(NAME ${f} ${common_args} -sf=*${f})
endforeach()

# queries
doctest_add_test(NAME version           COMMAND $<TARGET_FILE:${PROJECT_NAME}> -v)
doctest_add_test(NAME help              ${common_args} -h)
doctest_add_test(NAME count             ${common_args} -c   -sf=*coverage*)
doctest_add_test(NAME list_test_cases   ${common_args} -ltc -sf=*coverage*)
doctest_add_test(NAME list_test_suites  ${common_args} -lts -sf=*coverage*)

# options
doctest_add_test(NAME all_binary  ${common_args} -tc=all?binary* -s) # print all binary asserts - for getAssertString()
doctest_add_test(NAME abort_after ${common_args} -aa=2 -e=off   -sf=*coverage*) # abort after 2 assert fails and parse a negative
doctest_add_test(NAME first_last  ${common_args} -f=2 -l=4      -sf=*coverage*) # run a range
doctest_add_test(NAME filter_1    ${common_args} -ts=none) # should filter out all
doctest_add_test(NAME filter_2    COMMAND $<TARGET_FILE:${PROJECT_NAME}> -tse=* -nv) # should filter out all + print skipped
doctest_add_test(NAME filter_3    ${common_args} -sc=from*,sc* -sce=sc2 -sf=*subcases*) # enter a specific subcase - sc1
doctest_add_test(NAME order_1     ${common_args} -ob=suite -ns          -sf=*test_cases_and_suites*)
doctest_add_test(NAME order_2     ${common_args} -ob=name               -sf=*test_cases_and_suites*)
doctest_add_test(NAME order_3     ${common_args} -ob=rand               -sfe=*) # exclude everything for no output

################################################################################
## VARIATION OF THE BUILD WITH DOCTEST DISABLED - SHOULD STILL COMPILE
################################################################################

if(DEFINED ENV{CODE_COVERAGE})
    return() # do not continue with the disabled example
endif()

doctest_add_executable(disabled ${files})
target_compile_definitions(disabled PRIVATE DOCTEST_CONFIG_DISABLE)

doctest_add_test(NAME disabled COMMAND $<TARGET_FILE:disabled>)

# TODO: think about fixing these in a different way! - see issue #61 or commit 6b61e8aa3818c5ea100cedc1bb48a60ea10df6e8
if(MSVC)
    target_compile_options(disabled PRIVATE /wd4505) # unreferenced local function has been removed
    target_compile_options(disabled PRIVATE /wd4100) # unreferenced formal parameter
    target_compile_options(disabled PRIVATE /wd4189) # local variable is initialized but not referenced
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    target_compile_options(disabled PRIVATE -Wno-unknown-warning-option)
    target_compile_options(disabled PRIVATE -Wno-unneeded-internal-declaration)
    target_compile_options(disabled PRIVATE -Wno-unused-function)
    target_compile_options(disabled PRIVATE -Wno-unused-parameter)
    target_compile_options(disabled PRIVATE -Wno-unused-variable)
    target_compile_options(disabled PRIVATE -Wno-unused-template)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    target_compile_options(disabled PRIVATE -Wno-unused-function)
    target_compile_options(disabled PRIVATE -Wno-unused-parameter)
    target_compile_options(disabled PRIVATE -Wno-unused-variable)
endif()

=== examples/exe_with_static_libs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(exe_with_static_libs)

include(../../scripts/cmake/common.cmake)

include_directories(../../doctest/)

#== create object libraries instead of static libraries
doctest_add_library(lib_1 OBJECT lib_1_src1.cpp lib_1_src2.cpp)
doctest_add_library(lib_2 OBJECT lib_2_src.cpp)
doctest_add_executable(${PROJECT_NAME} main.cpp $<TARGET_OBJECTS:lib_1> $<TARGET_OBJECTS:lib_2>)

#== alternatively we could create static libraries and use "doctest_force_link_static_lib_in_target"
#doctest_add_library(lib_1 STATIC lib_1_src1.cpp lib_1_src2.cpp)
#doctest_add_library(lib_2 STATIC lib_2_src.cpp)
#doctest_add_executable(${PROJECT_NAME} main.cpp)
#target_link_libraries(${PROJECT_NAME} lib_1)
#target_link_libraries(${PROJECT_NAME} lib_2)
#include(doctest_force_link_static_lib_in_target.cmake)
#doctest_force_link_static_lib_in_target(${PROJECT_NAME} lib_1)
#doctest_force_link_static_lib_in_target(${PROJECT_NAME} lib_2)

#== group them together in a single folder inside IDEs
set_target_properties(lib_1 PROPERTIES FOLDER ${PROJECT_NAME})
set_target_properties(lib_2 PROPERTIES FOLDER ${PROJECT_NAME})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${PROJECT_NAME})

doctest_add_test(NAME ${PROJECT_NAME} COMMAND $<TARGET_FILE:${PROJECT_NAME}> --no-version)

=== scripts/playground/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(playground)

include(../cmake/common.cmake)

include_directories(../../doctest/)

doctest_add_executable(${PROJECT_NAME} main.cpp test.cpp)

doctest_add_test(NAME ${PROJECT_NAME} COMMAND $<TARGET_FILE:${PROJECT_NAME}> -nv)

=== debian/changelog ===
doctest (1.2.7+repack0-2) unstable; urgency=medium

  * Cleanup d/control thanks to `cme update dpkg-control`
  * Update Vcs-* for the move to Salsa

 -- Didier Raboud <odyx@debian.org>  Fri, 23 Feb 2018 20:52:58 +0100

doctest (1.2.7+repack0-1) unstable; urgency=medium

  * New upstream release

 -- Didier Raboud <odyx@debian.org>  Fri, 09 Feb 2018 00:10:27 +0100

doctest (1.2.6+repack0-2) unstable; urgency=medium

  * Initialize git-dpm; add patch:
    - Correct DOCTEST_NO_INSTALL logic; do install unless it is set
      (Closes: #880721)
  * Actually verify that the mandatory files are really installed

 -- Didier Raboud <odyx@debian.org>  Sat, 04 Nov 2017 15:28:11 +0100

doctest (1.2.6+repack0-1) unstable; urgency=medium

  * New 1.2.6 release
    - doc/html_generated is removed; as it contains strapdown.js and a minified
      Bootstrap CSS

 -- Didier Raboud <odyx@debian.org>  Thu, 02 Nov 2017 18:24:37 +0100

doctest (1.2.5+repack0-2) unstable; urgency=medium

  * Mark doctest-dev Multi-Arch: foreign
  * As upstream tarball is repacked, mangle the version in debian/watch
  * Add debian/gbp.conf

 -- Didier Raboud <odyx@debian.org>  Mon, 23 Oct 2017 13:22:45 +0200

doctest (1.2.5+repack0-1) unstable; urgency=low

  * Initial release. (Closes: #879103)

  * Repack the original 1.2.5:
    - doc/html_generated is removed; as it contains strapdown.js and a minified
      Bootstrap CSS

 -- Didier Raboud <odyx@debian.org>  Fri, 20 Oct 2017 08:48:53 +0200

=== debian/control ===
Source: doctest
Maintainer: Didier Raboud <odyx@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 10.2.5~),
               cmake,
               doxygen
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/debian/doctest
Vcs-Git: https://salsa.debian.org/debian/doctest.git
Homepage: https://github.com/onqtam/doctest

Package: doctest-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Light and feature-rich C++ testing framework
 doctest is a light and feature-rich C++98 / C++11 single-header testing
 framework for unit tests and TDD.
 .
 It is inspired by the unittest {} functionality of the D programming
 language and Python's docstrings - tests can be considered a form of
 documentation and should be able to reside near the production code
 which they test. This isn't possible (or at least practical) with any
 other testing framework for C++.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_EXPORT_COMPILE_COMMANDS=ON \
	                     -DCMAKE_CXX_FLAGS="-fprofile-arcs -ftest-coverage -std=c++98" \
	                     -DCMAKE_BUILD_TYPE=Debug

override_dh_auto_test:
	dh_auto_test --no-parallel -- ARGS\+=--output-on-failure

override_dh_compress:
	dh_compress -X.md$

override_dh_install:
	dh_install
	# Verify that the mandatory files are really installed
	[ -r debian/doctest-dev/usr/include/doctest/doctest.h ]
	[ -x debian/doctest-dev/usr/lib/cmake/doctest ]

## doctest 1.2.9%2Brepack0

=== scripts/how_stuff_works/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(how_stuff_works)

add_executable(how_captures_work how_captures_work.cpp)
add_executable(how_exception_translators_work how_exception_translators_work.cpp)
add_executable(how_subcases_work how_subcases_work.cpp)

## doctest 1.2.9+repack0

=== scripts/playground/CMakeLists.txt ===
--- 
+++ 
@@ -9,3 +9,6 @@
 doctest_add_executable(${PROJECT_NAME} main.cpp test.cpp)
 
 doctest_add_test(NAME ${PROJECT_NAME} COMMAND $<TARGET_FILE:${PROJECT_NAME}> -nv)
+
+#add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD COMMAND $<TARGET_FILE:${PROJECT_NAME}>)
+#add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD COMMAND ctest -C $<CONFIGURATION> --output-on-failure)

=== debian/changelog ===
doctest (1.2.9+repack0-1) unstable; urgency=medium

  * New 1.2.9 upstream release
  * Bump S-V to 4.1.4 without changes needed
  * Bump debhelper compat to 11

 -- Didier Raboud <odyx@debian.org>  Mon, 14 May 2018 14:37:40 +0200

doctest (1.2.8+repack0-1) unstable; urgency=medium

  * New 1.2.8 upstream release

 -- Didier Raboud <odyx@debian.org>  Sat, 10 Mar 2018 15:17:36 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Maintainer: Didier Raboud <odyx@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>= 10.2.5~),
+Build-Depends: debhelper (>= 11~),
                cmake,
                doxygen
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Vcs-Browser: https://salsa.debian.org/debian/doctest
 Vcs-Git: https://salsa.debian.org/debian/doctest.git
 Homepage: https://github.com/onqtam/doctest

## doctest 2.3.3+repack0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,27 +8,59 @@
 project(doctest VERSION ${ver})
 
 option(DOCTEST_WITH_TESTS               "Build tests/examples" ON)
-option(DOCTEST_WITH_MAIN_IN_STATIC_LIB  "Build a static lib (cmake target) with a main entry point" ON)
+option(DOCTEST_WITH_MAIN_IN_STATIC_LIB  "Build a static lib (cmake target) with a default main entry point" ON)
 option(DOCTEST_NO_INSTALL  "Skip the installation process" OFF)
 
 add_library(${PROJECT_NAME} INTERFACE)
-target_include_directories(${PROJECT_NAME} INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/doctest/>)
+
+set(doctest_parts_folder "${CMAKE_CURRENT_SOURCE_DIR}/doctest/parts")
+
+if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
+    # use a special hidden version of the header which directly includes the 2 parts - proper reporting of file/line locations during dev
+    target_include_directories(${PROJECT_NAME} INTERFACE
+        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/scripts/development_only/>
+        $<BUILD_INTERFACE:${doctest_parts_folder}>)
+
+    # add a custom target that assembles the single header when any of the parts are touched
+    add_custom_command(
+        OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/doctest/doctest.h
+        DEPENDS
+            ${doctest_parts_folder}/doctest_fwd.h
+            ${doctest_parts_folder}/doctest.cpp
+        COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/scripts/cmake/assemble_single_header.cmake
+        COMMENT "assembling the single header")
+
+    add_custom_target(assemble_single_header ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/doctest/doctest.h)
+else()
+    target_include_directories(${PROJECT_NAME} INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>)
+endif()
+
+# hack to support building on XCode 6 and 7 - propagate the definition to everything
+if(DEFINED DOCTEST_THREAD_LOCAL)
+    target_compile_definitions(${PROJECT_NAME} INTERFACE
+        DOCTEST_THREAD_LOCAL=${DOCTEST_THREAD_LOCAL})
+endif()
 
 ################################################################################
 ## TESTS/EXAMPLES/HELPERS
 ################################################################################
 
 if(${DOCTEST_WITH_MAIN_IN_STATIC_LIB})
-    include(scripts/cmake/common.cmake)
-    doctest_add_library(${PROJECT_NAME}_with_main STATIC EXCLUDE_FROM_ALL doctest/parts/doctest_main.cpp)
+    add_library(${PROJECT_NAME}_with_main STATIC EXCLUDE_FROM_ALL ${doctest_parts_folder}/doctest.cpp)
+    target_compile_definitions(${PROJECT_NAME}_with_main PRIVATE
+        DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN)
+    set_target_properties(${PROJECT_NAME}_with_main PROPERTIES
+        CXX_STANDARD 11
+        CXX_STANDARD_REQUIRED ON)
     target_link_libraries(${PROJECT_NAME}_with_main PUBLIC ${PROJECT_NAME})
 endif()
 
-if(${DOCTEST_WITH_TESTS})
+if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR AND DOCTEST_WITH_TESTS)
     include(scripts/cmake/common.cmake)
 
     add_subdirectory(examples/all_features)
     
+    # for code coverage we want exactly one binary to be produced and exercised
     if(NOT DEFINED ENV{CODE_COVERAGE})
         add_subdirectory(examples/exe_with_static_libs)
         add_subdirectory(examples/executable_dll_and_plugin)
@@ -42,8 +74,15 @@
 
 set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")
 
-set(include_install_dir "include/doctest/")
-set(config_install_dir "lib/cmake/${PROJECT_NAME}")
+if(CMAKE_SYSTEM_NAME STREQUAL Linux)
+    include(GNUInstallDirs)
+    set(include_install_dir ${CMAKE_INSTALL_INCLUDEDIR})
+    set(config_install_dir "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
+else()
+    set(include_install_dir "include")
+    set(config_install_dir "lib/cmake/${PROJECT_NAME}")
+endif()
+
 
 set(version_config "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
 set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
@@ -51,13 +90,23 @@
 set(namespace "${PROJECT_NAME}::")
 
 include(CMakePackageConfigHelpers)
+
+# CMake automatically adds an architecture compatibility check to make sure
+# 32 and 64 bit code is not accidentally mixed. For a header-only library this
+# is not required. The check can be disabled by temporarily unsetting
+# CMAKE_SIZEOF_VOID_P. In CMake 3.14 and later this can be achieved more cleanly
+# with write_basic_package_version_file(ARCH_INDEPENDENT).
+# TODO: Use this once a newer CMake can be required.
+set(DOCTEST_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
+unset(CMAKE_SIZEOF_VOID_P)
 write_basic_package_version_file(
     "${version_config}" VERSION ${PROJECT_VERSION} COMPATIBILITY SameMajorVersion
 )
+set(CMAKE_SIZEOF_VOID_P ${DOCTEST_SIZEOF_VOID_P})
 
 configure_file("scripts/cmake/Config.cmake.in" "${project_config}" @ONLY)
 
-if (NOT ${DOCTEST_NO_INSTALL})
+if(NOT ${DOCTEST_NO_INSTALL})
     install(
         TARGETS ${PROJECT_NAME}
         EXPORT "${targets_export_name}"
@@ -66,11 +115,16 @@
 
     install(
         FILES "doctest/doctest.h"
-        DESTINATION "${include_install_dir}"
+        DESTINATION "${include_install_dir}/doctest"
     )
 
     install(
         FILES "${project_config}" "${version_config}"
+        DESTINATION "${config_install_dir}"
+    )
+
+    install(
+        FILES "scripts/cmake/doctest.cmake" "scripts/cmake/doctestAddTests.cmake"
         DESTINATION "${config_install_dir}"
     )

=== examples/all_features/CMakeLists.txt ===
--- 
+++ 
@@ -1,56 +1,71 @@
-cmake_minimum_required(VERSION 3.0)
-
-project(all_features)
-
-include(../../scripts/cmake/common.cmake)
-
-include_directories(../../doctest/)
-
 ################################################################################
 ## BUILD ALL EXAMPLE SOURCES INTO A SINGLE BINARY AND EXECUTE TESTS ON EACH FILE
 ################################################################################
 
-set(files
+set(files_with_output
     main.cpp
     doctest_proxy.h
     header.h
-    coverage_maxout.cpp
     alternative_macros.cpp
     assertion_macros.cpp
     stringification.cpp
+    reporters_and_listeners.cpp
     subcases.cpp
     logging.cpp
     templated_test_cases.cpp
     test_cases_and_suites.cpp
+    asserts_used_outside_of_tests.cpp
 )
 
-doctest_add_executable(${PROJECT_NAME} ${files})
+set(files_all
+    ${files_with_output}
+    concurrency.cpp
+    ../../scripts/coverage_maxout.cpp
+)
+
+# add the executable
+add_executable(all_features ${files_all})
+target_link_libraries(all_features doctest ${CMAKE_THREAD_LIBS_INIT})
+
 # easy way to fix test coverage - disable colors and crash handling
-target_compile_definitions(${PROJECT_NAME} PRIVATE
+target_compile_definitions(all_features PRIVATE
     DOCTEST_CONFIG_COLORS_NONE
     DOCTEST_CONFIG_NO_POSIX_SIGNALS
     DOCTEST_CONFIG_NO_WINDOWS_SEH)
 
-set(common_args COMMAND $<TARGET_FILE:${PROJECT_NAME}> --no-skipped-summary --no-version)
+# omit the version and the num test cases skipped from the summary - this way the output will change less often
+set(common_args COMMAND $<TARGET_FILE:all_features> --no-skipped-summary --no-version)
 
 # add per-file tests
-foreach(f ${files})
+foreach(f ${files_with_output})
     doctest_add_test(NAME ${f} ${common_args} -sf=*${f})
 endforeach()
 
+# add this separately since it shouldn't have output compared to reference output - due to concurrency
+# not adding it for MinGW since it crashes when using mingw-w64-x86_64-8.1.0-release-posix-seh-rt_v6-rev0
+# (also disabled for old XCode builds on travis where there is no thread_local support and this is defined in the build matrix)
+if(NOT MINGW AND NOT DEFINED DOCTEST_THREAD_LOCAL)
+    doctest_add_test(NO_OUTPUT NAME concurrency.cpp ${common_args} -sf=*concurrency.cpp -d) # duration: there is no output anyway
+endif()
+
+# add this separately since the file has a non-straightforward path
+doctest_add_test(NAME coverage_maxout.cpp ${common_args} -sf=*coverage_maxout.cpp)
+
 # queries
-doctest_add_test(NAME version           COMMAND $<TARGET_FILE:${PROJECT_NAME}> -v)
+doctest_add_test(NAME version           COMMAND $<TARGET_FILE:all_features> -v)
 doctest_add_test(NAME help              ${common_args} -h)
+doctest_add_test(NO_OUTPUT NAME outfile ${common_args} -c   -out=temp) # just to exercise the output option
 doctest_add_test(NAME count             ${common_args} -c   -sf=*coverage*)
 doctest_add_test(NAME list_test_cases   ${common_args} -ltc -sf=*coverage*)
 doctest_add_test(NAME list_test_suites  ${common_args} -lts -sf=*coverage*)
+doctest_add_test(NAME list_reporters    ${common_args} -lr  -sf=*coverage*)
 
 # options
 doctest_add_test(NAME all_binary  ${common_args} -tc=all?binary* -s) # print all binary asserts - for getAssertString()
 doctest_add_test(NAME abort_after ${common_args} -aa=2 -e=off   -sf=*coverage*) # abort after 2 assert fails and parse a negative
 doctest_add_test(NAME first_last  ${common_args} -f=2 -l=4      -sf=*coverage*) # run a range
 doctest_add_test(NAME filter_1    ${common_args} -ts=none) # should filter out all
-doctest_add_test(NAME filter_2    COMMAND $<TARGET_FILE:${PROJECT_NAME}> -tse=* -nv) # should filter out all + print skipped
+doctest_add_test(NAME filter_2    COMMAND $<TARGET_FILE:all_features>   -tse=* -nv) # should filter out all + print skipped
 doctest_add_test(NAME filter_3    ${common_args} -sc=from*,sc* -sce=sc2 -sf=*subcases*) # enter a specific subcase - sc1
 doctest_add_test(NAME order_1     ${common_args} -ob=suite -ns          -sf=*test_cases_and_suites*)
 doctest_add_test(NAME order_2     ${common_args} -ob=name               -sf=*test_cases_and_suites*)
@@ -64,8 +79,9 @@
     return() # do not continue with the disabled example
 endif()
 
-doctest_add_executable(disabled ${files})
+add_executable(disabled ${files_all})
 target_compile_definitions(disabled PRIVATE DOCTEST_CONFIG_DISABLE)
+target_link_libraries(disabled doctest ${CMAKE_THREAD_LIBS_INIT})
 
 doctest_add_test(NAME disabled COMMAND $<TARGET_FILE:disabled>)

=== examples/installed_doctest_cmake/executable/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(example_exe VERSION 0.0.1 LANGUAGES CXX)

find_package(doctest REQUIRED)

add_executable(${PROJECT_NAME} main.cpp)
target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_17)
target_link_libraries(${PROJECT_NAME} doctest::doctest)

=== debian/changelog ===
doctest (2.3.3+repack0-2) experimental; urgency=medium

  * Add gitlab-ci configuration for Salsa
  * Use dpkg-buildflags' CXXFLAGS with CPPFLAGS appended to circumvent CMake

 -- Didier Raboud <odyx@debian.org>  Fri, 21 Jun 2019 17:27:54 +0200

doctest (2.3.3+repack0-1) experimental; urgency=medium

  * New 2.3.3 upstream release

 -- Didier Raboud <odyx@debian.org>  Fri, 21 Jun 2019 16:42:28 +0200

doctest (2.3.2+repack0-1) experimental; urgency=medium

  * New 2.3.2 upstream release

  * debian/rules improvements:
    - Configure to use C++11, not C++98
    - Override CMAKE_INSTALL_LIBDIR to leave the CMake configurations
      in an arch-indep location
    - Fix dh_compress -X' syntax
  * Bump S-V to 4.3.0
  * Bump debhelper compat to 12
  * Install examples

 -- Didier Raboud <odyx@debian.org>  Sun, 19 May 2019 10:43:03 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Maintainer: Didier Raboud <odyx@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                doxygen
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/debian/doctest
 Vcs-Git: https://salsa.debian.org/debian/doctest.git
 Homepage: https://github.com/onqtam/doctest

## doctest 2.3.4+repack0

=== debian/changelog ===
doctest (2.3.4+repack0-1) unstable; urgency=medium

  * New 2.3.4 upstream release, to unstable

  * Update standards version, no changes needed.
  * Set upstream metadata fields: Contact, Name.

 -- Didier Raboud <odyx@debian.org>  Sun, 18 Aug 2019 17:50:56 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 12),
                cmake,
                doxygen
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/debian/doctest
 Vcs-Git: https://salsa.debian.org/debian/doctest.git
 Homepage: https://github.com/onqtam/doctest

## doctest 2.3.6%2Brepack0

=== examples/all_features/CMakeLists.txt ===
--- 
+++ 
@@ -65,7 +65,8 @@
 doctest_add_test(NAME abort_after ${common_args} -aa=2 -e=off   -sf=*coverage*) # abort after 2 assert fails and parse a negative
 doctest_add_test(NAME first_last  ${common_args} -f=2 -l=4      -sf=*coverage*) # run a range
 doctest_add_test(NAME filter_1    ${common_args} -ts=none) # should filter out all
-doctest_add_test(NAME filter_2    COMMAND $<TARGET_FILE:all_features>   -tse=* -nv) # should filter out all + print skipped
+# -order-by=name to avoid different output depending on the compiler used. See https://github.com/onqtam/doctest/issues/287
+doctest_add_test(NAME filter_2    COMMAND $<TARGET_FILE:all_features>   -tse=* -nv -order-by=name) # should filter out all + print skipped
 doctest_add_test(NAME filter_3    ${common_args} -sc=from*,sc* -sce=sc2 -sf=*subcases*) # enter a specific subcase - sc1
 doctest_add_test(NAME order_1     ${common_args} -ob=suite -ns          -sf=*test_cases_and_suites*)
 doctest_add_test(NAME order_2     ${common_args} -ob=name               -sf=*test_cases_and_suites*)
@@ -90,7 +91,9 @@
     target_compile_options(disabled PRIVATE /wd4505) # unreferenced local function has been removed
     target_compile_options(disabled PRIVATE /wd4100) # unreferenced formal parameter
     target_compile_options(disabled PRIVATE /wd4189) # local variable is initialized but not referenced
-elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+endif()
+
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     target_compile_options(disabled PRIVATE -Wno-unknown-warning-option)
     target_compile_options(disabled PRIVATE -Wno-unneeded-internal-declaration)
     target_compile_options(disabled PRIVATE -Wno-unused-function)

## doctest 2.3.6+repack0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,18 @@
 ################################################################################
 
 file(READ ${CMAKE_CURRENT_SOURCE_DIR}/scripts/version.txt ver)
-project(doctest VERSION ${ver})
+project(doctest VERSION ${ver} LANGUAGES CXX)
 
 option(DOCTEST_WITH_TESTS               "Build tests/examples" ON)
 option(DOCTEST_WITH_MAIN_IN_STATIC_LIB  "Build a static lib (cmake target) with a default main entry point" ON)
 option(DOCTEST_NO_INSTALL  "Skip the installation process" OFF)
 
 add_library(${PROJECT_NAME} INTERFACE)
+add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})
+
+if(NOT CMAKE_VERSION VERSION_LESS 3.8) 
+    target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_11)
+endif()
 
 set(doctest_parts_folder "${CMAKE_CURRENT_SOURCE_DIR}/doctest/parts")
 
@@ -49,9 +54,7 @@
     add_library(${PROJECT_NAME}_with_main STATIC EXCLUDE_FROM_ALL ${doctest_parts_folder}/doctest.cpp)
     target_compile_definitions(${PROJECT_NAME}_with_main PRIVATE
         DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN)
-    set_target_properties(${PROJECT_NAME}_with_main PROPERTIES
-        CXX_STANDARD 11
-        CXX_STANDARD_REQUIRED ON)
+    set_target_properties(${PROJECT_NAME}_with_main PROPERTIES CXX_STANDARD 11 CXX_STANDARD_REQUIRED ON)
     target_link_libraries(${PROJECT_NAME}_with_main PUBLIC ${PROJECT_NAME})
 endif()
 
@@ -59,7 +62,7 @@
     include(scripts/cmake/common.cmake)
 
     add_subdirectory(examples/all_features)
-    
+
     # for code coverage we want exactly one binary to be produced and exercised
     if(NOT DEFINED ENV{CODE_COVERAGE})
         add_subdirectory(examples/exe_with_static_libs)

=== examples/installed_doctest_cmake/dll/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(example_dll VERSION 0.0.1 LANGUAGES CXX)

find_package(doctest REQUIRED)

add_library("dll" SHARED dll.cpp)
target_compile_features("dll" PRIVATE cxx_std_17)
target_compile_definitions("dll" PUBLIC -D_EXPORT)
target_link_libraries("dll" doctest::doctest)

add_executable(${PROJECT_NAME} main.cpp)
target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_17)
target_link_libraries(${PROJECT_NAME} dll)

=== debian/changelog ===
doctest (2.3.6+repack0-1) unstable; urgency=medium

  * New 2.3.6+repack0 upstream release

 -- Didier Raboud <odyx@debian.org>  Mon, 23 Dec 2019 18:03:46 +0100

doctest (2.3.5+repack0-1) unstable; urgency=medium

  * New 2.3.5 upstream release

  * Unset redundant upstream metadata

 -- Didier Raboud <odyx@debian.org>  Fri, 27 Sep 2019 10:50:55 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 12),
                cmake,
                doxygen
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/debian/doctest
 Vcs-Git: https://salsa.debian.org/debian/doctest.git
 Homepage: https://github.com/onqtam/doctest

=== debian/watch ===
version=3
opts="dversionmangle=s/\+repack\d*$//,repacksuffix=+repack,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/doctest-$1\.tar\.gz/" \
  https://github.com/onqtam/doctest/tags .*/v?(\d\S+)\.tar\.gz

## doctest 2.4.0+repack0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
 cmake_minimum_required(VERSION 3.0)
+
+if(POLICY CMP0077)
+    cmake_policy(SET CMP0077 NEW)
+endif()
 
 ################################################################################
 ## DOCTEST

=== debian/changelog ===
doctest (2.4.0+repack0-1) unstable; urgency=medium

  * Update to new upstream version 2.4.0+repack0

 -- Didier Raboud <odyx@debian.org>  Tue, 30 Jun 2020 13:10:23 +0200

doctest (2.3.8+repack0-1) unstable; urgency=medium

  * Update to new upstream version 2.3.8+repack0.
  * Bump debhelper from old 12 to 13.

 -- Didier Raboud <odyx@debian.org>  Mon, 25 May 2020 21:36:27 +0200

doctest (2.3.7+repack0-1) unstable; urgency=medium

  * Update to new upstream version 2.3.7+repack0
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Bump Standards-Version to 4.5.0 without changes needed

 -- Didier Raboud <odyx@debian.org>  Fri, 28 Feb 2020 11:02:29 +0100

## doctest 2.4.1+repack0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,21 +14,24 @@
 option(DOCTEST_WITH_TESTS               "Build tests/examples" ON)
 option(DOCTEST_WITH_MAIN_IN_STATIC_LIB  "Build a static lib (cmake target) with a default main entry point" ON)
 option(DOCTEST_NO_INSTALL  "Skip the installation process" OFF)
+option(DOCTEST_USE_STD_HEADERS  "Use std headers" OFF)
 
 add_library(${PROJECT_NAME} INTERFACE)
 add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})
 
-if(NOT CMAKE_VERSION VERSION_LESS 3.8) 
+if(NOT CMAKE_VERSION VERSION_LESS 3.8)
     target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_11)
 endif()
 
 set(doctest_parts_folder "${CMAKE_CURRENT_SOURCE_DIR}/doctest/parts")
+set(doctest_folder "${CMAKE_CURRENT_SOURCE_DIR}/") # in order to have the mpi extension files, not included into the doctest.h single header
 
 if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
     # use a special hidden version of the header which directly includes the 2 parts - proper reporting of file/line locations during dev
     target_include_directories(${PROJECT_NAME} INTERFACE
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/scripts/development_only/>
-        $<BUILD_INTERFACE:${doctest_parts_folder}>)
+        $<BUILD_INTERFACE:${doctest_parts_folder}>
+        $<BUILD_INTERFACE:${doctest_folder}>)
 
     # add a custom target that assembles the single header when any of the parts are touched
     add_custom_command(
@@ -48,6 +51,10 @@
 if(DEFINED DOCTEST_THREAD_LOCAL)
     target_compile_definitions(${PROJECT_NAME} INTERFACE
         DOCTEST_THREAD_LOCAL=${DOCTEST_THREAD_LOCAL})
+endif()
+
+if(DOCTEST_USE_STD_HEADERS)
+    target_compile_definitions(${PROJECT_NAME} INTERFACE DOCTEST_CONFIG_USE_STD_HEADERS)
 endif()
 
 ################################################################################
@@ -72,6 +79,7 @@
         add_subdirectory(examples/exe_with_static_libs)
         add_subdirectory(examples/executable_dll_and_plugin)
         add_subdirectory(scripts/playground)
+        add_subdirectory(examples/mpi)
     endif()
 endif()

=== debian/changelog ===
doctest (2.4.1+repack0-1) unstable; urgency=medium

  * Update to new upstream version 2.4.1+repack0

 -- Didier Raboud <odyx@debian.org>  Fri, 06 Nov 2020 18:32:32 +0100

## doctest 2.4.4+repack0

=== debian/changelog ===
doctest (2.4.4+repack0-1) unstable; urgency=medium

  * Update to new upstream version 2.4.4+repack0.
  * Update watch file format version to 4.

 -- Didier Raboud <odyx@debian.org>  Tue, 29 Dec 2020 11:18:36 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Maintainer: Didier Raboud <odyx@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                doxygen
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian/doctest
 Vcs-Git: https://salsa.debian.org/debian/doctest.git
 Homepage: https://github.com/onqtam/doctest
